net.i2p.data.i2cp

## Interface I2CPMessageReader.I2CPMessageEventListener

- All Known Implementing Classes:
    ClientMessageEventListener, I2PSessionImpl, I2PSessionImpl2, I2PSessionMuxedImpl, I2PSimpleSession
  Enclosing class:
    I2CPMessageReader

      public static interface I2CPMessageReader.I2CPMessageEventListener

  Defines the different events the reader produces while reading the stream

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `disconnected(I2CPMessageReader reader)` Notify the listener that the stream the given reader was running off closed
    `void` | `messageReceived(I2CPMessageReader reader, I2CPMessage message)` Notify the listener that a message has been received from the given reader
    `void` | `readError(I2CPMessageReader reader, Exception error)` Notify the listener that an exception was thrown while reading from the given reader

- - ### Method Detail

    - #### messageReceived

          void messageReceived(I2CPMessageReader reader,
                             I2CPMessage message)

      Notify the listener that a message has been received from the given reader
      Parameters:
        `reader` - I2CPMessageReader to notify
        `message` - the I2CPMessage

    - #### readError

          void readError(I2CPMessageReader reader,
                       Exception error)

      Notify the listener that an exception was thrown while reading from the given reader
      Parameters:
        `reader` - I2CPMessageReader to notify
        `error` - Exception that was thrown

    - #### disconnected

          void disconnected(I2CPMessageReader reader)

      Notify the listener that the stream the given reader was running off closed
      Parameters:
        `reader` - I2CPMessageReader to notify